import 'package:flutter/material.dart';
import 'package:insuideindoor/Constant.dart';

import 'MarkerList.dart';
import 'itemLocationMap.dart';
import 'iteminfo.dart';

class ItemInfo extends StatefulWidget {
  MapMarker mapMarker;
  List<MapMarker> mapMarkerList;

  ItemInfo({Key? key, required this.mapMarker,required this.mapMarkerList}) : super(key: key);

  @override
  State<ItemInfo> createState() => _ItemInfoState();
}

class _ItemInfoState extends State<ItemInfo> {
  @override
  Widget build(BuildContext context) {
    print(widget.mapMarker);
    return Material(
      child: Padding(
        padding: const EdgeInsets.all(12),
        child: ListView(
          children: <Widget>[

          SizedBox(
            height: 25,
          ) ,
            ListTile(
              leading: Image.asset(
                widget.mapMarker.img,
                height: 55,
                width: 55,
              ),
              title: Text(widget.mapMarker.title,
                  style: TextStyle(fontSize: 22, fontStyle: FontStyle.normal)),
              subtitle: Text(
                "Security Hold Area . 1km away" +
                    "\n" +
                    "Terminal " +
                    widget.mapMarker.terminal,
                style:
                TextStyle(fontSize: 14, color: Color.fromRGBO(51, 51, 51, 1)),
              ),
            ),
            SizedBox(
              height: 10,
            ),
            Directionality(
                textDirection: TextDirection.rtl,
                child: Container(
                  height: 50,
                  child: ElevatedButton.icon(
                    onPressed: () {
                      _navigateToNextScreenMap(context, widget.mapMarker);
                      print("You pressed Icon Elevated Button");
                    },
                    //icon data for elevated button
                    label: Text(
                      "Get Directions",
                      style: TextStyle(
                          color: Color.fromRGBO(34, 34, 34, 1), fontSize: 18),
                    ),

                    icon: Image.asset("assets/image/navigation_icon.png"),
                    //label text
                    style: ElevatedButton.styleFrom(
                      primary: Colors.white,
                      shape: RoundedRectangleBorder(
                          borderRadius: BorderRadius.circular(25),
                          side: BorderSide(
                              color: Color.fromRGBO(34, 34, 34, 1))),
                    ),
                  ),
                )),
            SizedBox(
              height: 20.0,
            ),
            Card(
              semanticContainer: true,
              clipBehavior: Clip.antiAliasWithSaveLayer,
              child: Image.network(
                widget.mapMarker.bannerUrl,
                width: 374,
                height: 250,
                fit: BoxFit.cover,
              ),
              shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(10.0),
              ),
            ),
            SizedBox(
              height: 10.0,
            ),
            Padding(
                padding: const EdgeInsets.only(right: 14.0, left: 14.0),
                child: Text(
                  widget.mapMarker.description,
                  style:
                  TextStyle(color: Color.fromRGBO(34, 34, 34, 1), fontSize: 16),
                )),
            SizedBox(
              height: 25.0,
            ),
            Padding(
              padding: const EdgeInsets.only(left: 15, right: 10),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  Align(
                    alignment: Alignment.centerLeft,
                    child: Text(
                      "Information",
                      style: TextStyle(
                          fontSize: 16,
                          color: Color.fromRGBO(102, 102, 102, 1),
                          fontStyle: FontStyle.italic),
                    ),
                  )
                ],
              ),
            ),
            SizedBox(
              height: 20,
            ),
            ListTile(
              leading: Image.asset(
                "assets/image/call.png",
                height: 40,
                width: 30,
              ),
              title: Text("087464664",
                  style: TextStyle(fontSize: 18, fontStyle: FontStyle.normal)),
            ),
            ListTile(
              leading: Image.asset(
                "assets/image/clock.png",
                height: 40,
                width: 30,
              ),
              title: Text("087464664",
                  style: TextStyle(fontSize: 18, fontStyle: FontStyle.normal)),
            )
          ],
        ),
      ),
    );
  }



  void _navigateToNextScreenMap(BuildContext context, MapMarker mapMarker) {
    Navigator.of(context).push(MaterialPageRoute(
      builder: (context) =>
          ItemLocationMapScreen(
            mapMarker: mapMarker,
            mapMarkerList: widget.mapMarkerList,
          ),
    ));
  }
}
