import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:insuideindoor/MarkerList.dart';

class SearchItemInfoScreen extends StatefulWidget {
  List<MapMarker> mapMarkerList;
  bool isNavTooView;

  SearchItemInfoScreen({Key? key, required this.mapMarkerList,required this.isNavTooView})
      : super(key: key);

  @override
  State<SearchItemInfoScreen> createState() => _SearchItemInfoScreenState();
}

class _SearchItemInfoScreenState extends State<SearchItemInfoScreen> {
  List<MapMarker> serachList = [];

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    serachList = widget.mapMarkerList;
    print(widget.mapMarkerList.length);
  }

  void _runFilter(String enteredKeyword) {
    List<MapMarker> results = [];
    if (enteredKeyword.isEmpty) {
      results = widget.mapMarkerList;
    } else {
      results = widget.mapMarkerList
          .where((x) =>
              x.title.toLowerCase().contains(enteredKeyword.toLowerCase()))
          .toList();
    }

    setState(() {
      serachList = results;
    });
  }

  @override
  Widget build(BuildContext context) {
    return Material(
      child: Container(
        alignment: Alignment.topCenter,
        child: Column(
          children: [
            SizedBox(
              height: 65,
            ),
            Padding(
              padding: const EdgeInsets.only(right: 10.0, left: 10.0),
              child: SizedBox(
                  width: double.infinity,
                  height: 45,
                  child: TextField(
                    onChanged: (value) => _runFilter(value),
                    decoration: InputDecoration(
                        border: OutlineInputBorder(
                          borderRadius: BorderRadius.circular(25.0),
                        ),
                        hintStyle:
                            TextStyle(color: Color.fromRGBO(51, 51, 51, 1)),
                        hintText: "",
                        contentPadding:
                            const EdgeInsets.only(left: 20, right: 10, top: 10),
                        filled: true,
                        fillColor: Color.fromRGBO(255, 255, 255, 1)),
                  )),
            ),
            SizedBox(
              height: 30,
            ),

            Visibility(visible : !widget.isNavTooView,child: Column(
              children: [
                Padding(
                  padding: const EdgeInsets.only(right: 10.0, left: 10.0),
                  child: SizedBox(
                      width: double.infinity,
                      height: 45,
                      child: TextField(
                        onChanged: (value) => _runFilter(value),
                        decoration: InputDecoration(
                            border: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(25.0),
                            ),
                            hintStyle:
                            TextStyle(color: Color.fromRGBO(51, 51, 51, 1)),
                            hintText: "",
                            contentPadding:
                            const EdgeInsets.only(left: 20, right: 10, top: 10),
                            filled: true,
                            fillColor: Color.fromRGBO(255, 255, 255, 1)),
                      )),
                )
              ],
            )),

            SizedBox(
              height: 30,
            ),



            if (serachList.isNotEmpty)
              Expanded(
                child: ListView.builder(
                    scrollDirection: Axis.vertical,
                    shrinkWrap: true,
                    itemCount: serachList.length,
                    itemBuilder: (BuildContext context, int index) {
                      return ListTile(
                        leading: Image.asset(serachList[index].img),
                        title: Text(serachList[index].title),
                        subtitle: Text(serachList[index].description),
                      );
                    },),
              )
          ],
        ),
      ),
    );
  }
}
